# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.boolean_type import BooleanType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.code_type import CodeType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501


class Coding(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'system': 'str',
        'version': 'str',
        'code': 'str',
        'display': 'str',
        'user_selected': 'bool',
        'version_element': 'StringType',
        'system_element': 'UriType',
        'code_element': 'CodeType',
        'display_element': 'StringType',
        'user_selected_element': 'BooleanType',
        'empty': 'bool',
        'id_element': 'StringType',
        'extension_first_rep': 'Extension',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'system': 'system',
        'version': 'version',
        'code': 'code',
        'display': 'display',
        'user_selected': 'userSelected',
        'version_element': 'versionElement',
        'system_element': 'systemElement',
        'code_element': 'codeElement',
        'display_element': 'displayElement',
        'user_selected_element': 'userSelectedElement',
        'empty': 'empty',
        'id_element': 'idElement',
        'extension_first_rep': 'extensionFirstRep',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, system=None, version=None, code=None, display=None, user_selected=None, version_element=None, system_element=None, code_element=None, display_element=None, user_selected_element=None, empty=None, id_element=None, extension_first_rep=None, id_base=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """Coding - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._system = None
        self._version = None
        self._code = None
        self._display = None
        self._user_selected = None
        self._version_element = None
        self._system_element = None
        self._code_element = None
        self._display_element = None
        self._user_selected_element = None
        self._empty = None
        self._id_element = None
        self._extension_first_rep = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if system is not None:
            self.system = system
        if version is not None:
            self.version = version
        if code is not None:
            self.code = code
        if display is not None:
            self.display = display
        if user_selected is not None:
            self.user_selected = user_selected
        if version_element is not None:
            self.version_element = version_element
        if system_element is not None:
            self.system_element = system_element
        if code_element is not None:
            self.code_element = code_element
        if display_element is not None:
            self.display_element = display_element
        if user_selected_element is not None:
            self.user_selected_element = user_selected_element
        if empty is not None:
            self.empty = empty
        if id_element is not None:
            self.id_element = id_element
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this Coding.  # noqa: E501


        :return: The format_comments_pre of this Coding.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this Coding.


        :param format_comments_pre: The format_comments_pre of this Coding.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this Coding.  # noqa: E501


        :return: The format_comments_post of this Coding.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this Coding.


        :param format_comments_post: The format_comments_post of this Coding.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this Coding.  # noqa: E501


        :return: The id of this Coding.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Coding.


        :param id: The id of this Coding.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this Coding.  # noqa: E501


        :return: The extension of this Coding.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this Coding.


        :param extension: The extension of this Coding.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this Coding.  # noqa: E501


        :return: The disallow_extensions of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this Coding.


        :param disallow_extensions: The disallow_extensions of this Coding.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def system(self):
        """Gets the system of this Coding.  # noqa: E501


        :return: The system of this Coding.  # noqa: E501
        :rtype: str
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this Coding.


        :param system: The system of this Coding.  # noqa: E501
        :type: str
        """

        self._system = system

    @property
    def version(self):
        """Gets the version of this Coding.  # noqa: E501


        :return: The version of this Coding.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Coding.


        :param version: The version of this Coding.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def code(self):
        """Gets the code of this Coding.  # noqa: E501


        :return: The code of this Coding.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this Coding.


        :param code: The code of this Coding.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def display(self):
        """Gets the display of this Coding.  # noqa: E501


        :return: The display of this Coding.  # noqa: E501
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this Coding.


        :param display: The display of this Coding.  # noqa: E501
        :type: str
        """

        self._display = display

    @property
    def user_selected(self):
        """Gets the user_selected of this Coding.  # noqa: E501


        :return: The user_selected of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._user_selected

    @user_selected.setter
    def user_selected(self, user_selected):
        """Sets the user_selected of this Coding.


        :param user_selected: The user_selected of this Coding.  # noqa: E501
        :type: bool
        """

        self._user_selected = user_selected

    @property
    def version_element(self):
        """Gets the version_element of this Coding.  # noqa: E501


        :return: The version_element of this Coding.  # noqa: E501
        :rtype: StringType
        """
        return self._version_element

    @version_element.setter
    def version_element(self, version_element):
        """Sets the version_element of this Coding.


        :param version_element: The version_element of this Coding.  # noqa: E501
        :type: StringType
        """

        self._version_element = version_element

    @property
    def system_element(self):
        """Gets the system_element of this Coding.  # noqa: E501


        :return: The system_element of this Coding.  # noqa: E501
        :rtype: UriType
        """
        return self._system_element

    @system_element.setter
    def system_element(self, system_element):
        """Sets the system_element of this Coding.


        :param system_element: The system_element of this Coding.  # noqa: E501
        :type: UriType
        """

        self._system_element = system_element

    @property
    def code_element(self):
        """Gets the code_element of this Coding.  # noqa: E501


        :return: The code_element of this Coding.  # noqa: E501
        :rtype: CodeType
        """
        return self._code_element

    @code_element.setter
    def code_element(self, code_element):
        """Sets the code_element of this Coding.


        :param code_element: The code_element of this Coding.  # noqa: E501
        :type: CodeType
        """

        self._code_element = code_element

    @property
    def display_element(self):
        """Gets the display_element of this Coding.  # noqa: E501


        :return: The display_element of this Coding.  # noqa: E501
        :rtype: StringType
        """
        return self._display_element

    @display_element.setter
    def display_element(self, display_element):
        """Sets the display_element of this Coding.


        :param display_element: The display_element of this Coding.  # noqa: E501
        :type: StringType
        """

        self._display_element = display_element

    @property
    def user_selected_element(self):
        """Gets the user_selected_element of this Coding.  # noqa: E501


        :return: The user_selected_element of this Coding.  # noqa: E501
        :rtype: BooleanType
        """
        return self._user_selected_element

    @user_selected_element.setter
    def user_selected_element(self, user_selected_element):
        """Sets the user_selected_element of this Coding.


        :param user_selected_element: The user_selected_element of this Coding.  # noqa: E501
        :type: BooleanType
        """

        self._user_selected_element = user_selected_element

    @property
    def empty(self):
        """Gets the empty of this Coding.  # noqa: E501


        :return: The empty of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this Coding.


        :param empty: The empty of this Coding.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def id_element(self):
        """Gets the id_element of this Coding.  # noqa: E501


        :return: The id_element of this Coding.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this Coding.


        :param id_element: The id_element of this Coding.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this Coding.  # noqa: E501


        :return: The extension_first_rep of this Coding.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this Coding.


        :param extension_first_rep: The extension_first_rep of this Coding.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_base(self):
        """Gets the id_base of this Coding.  # noqa: E501


        :return: The id_base of this Coding.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this Coding.


        :param id_base: The id_base of this Coding.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this Coding.  # noqa: E501


        :return: The resource of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Coding.


        :param resource: The resource of this Coding.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this Coding.  # noqa: E501


        :return: The boolean_primitive of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this Coding.


        :param boolean_primitive: The boolean_primitive of this Coding.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this Coding.  # noqa: E501


        :return: The date_time of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this Coding.


        :param date_time: The date_time of this Coding.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this Coding.  # noqa: E501


        :return: The primitive of this Coding.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this Coding.


        :param primitive: The primitive of this Coding.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Coding):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
